/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_SampleStatisticalDescriptors;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_SampleStatisticalDescriptors;


/**
 * This class represents SampleStatisticalDescriptors - CID227
 */
public class SampleStatisticalDescriptors_CID227  
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	
	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;
	
	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;
	
	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Instantiates a new SampleStatisticalDescriptors_CID227 Template 
	 */
	public SampleStatisticalDescriptors_CID227()
	{
		
	}
	
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumSampleStatisticalDescriptors Object of EnumCM_SampleStatisticalDescriptors represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_SampleStatisticalDescriptors enumSampleStatisticalDescriptors)
	{
		switch(enumSampleStatisticalDescriptors) 
		{
		case PERCENTILE_RANKING_OF_MEASUREMENT: this.strCodeValue =EnumCV_SampleStatisticalDescriptors.PERCENTILE_RANKING_OF_MEASUREMENT_121415.getValue(); break;
		case Z_SCORE_OF_MEASUREMENT: this.strCodeValue =EnumCV_SampleStatisticalDescriptors.Z_SCORE_OF_MEASUREMENT_121416.getValue(); break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumSampleStatisticalDescriptors Object of EnumCM_SampleStatisticalDescriptors represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_SampleStatisticalDescriptors enumSampleStatisticalDescriptors)
	{
		switch(enumSampleStatisticalDescriptors)
		{
		case PERCENTILE_RANKING_OF_MEASUREMENT : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.PERCENTILE_RANKING_OF_MEASUREMENT.getSNOMEDCTID(); break;
		case Z_SCORE_OF_MEASUREMENT : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.Z_SCORE_OF_MEASUREMENT.getSNOMEDCTID(); break;
		}
	}
	
	/**
	 * Sets the value for Sample Statistical Descriptors
	 * @param enumSampleStatisticalDescriptors Object of EnumCM_SampleStatisticalDescriptors.
	 */
	public void setSampleStatisticalDescriptors(EnumCM_SampleStatisticalDescriptors enumSampleStatisticalDescriptors)
	{
		this.strCodeMeaning = enumSampleStatisticalDescriptors.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		setCodeValue(enumSampleStatisticalDescriptors);
		setSNOMEDCTID(enumSampleStatisticalDescriptors);
	}
}
